//#line 2 "/opt/ros/fuerte/stacks/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the r2_dynamic_reconfigure package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __r2_dynamic_reconfigure__KTENDONCONFIG_H__
#define __r2_dynamic_reconfigure__KTENDONCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace r2_dynamic_reconfigure
{
  class kTendonConfigStatics;
  
  class kTendonConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(kTendonConfig &config, const kTendonConfig &max, const kTendonConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const kTendonConfig &config1, const kTendonConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, kTendonConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const kTendonConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, kTendonConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const kTendonConfig &config) const = 0;
      virtual void getValue(const kTendonConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T kTendonConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (kTendonConfig::* field);

      virtual void clamp(kTendonConfig &config, const kTendonConfig &max, const kTendonConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const kTendonConfig &config1, const kTendonConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, kTendonConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const kTendonConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, kTendonConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const kTendonConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const kTendonConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, kTendonConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); i++)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;
        
        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++) 
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }
      
      virtual void updateParams(boost::any &cfg, kTendonConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++) 
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<kTendonConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(kTendonConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = params.begin(); i != params.end(); i++)
      {
        boost::any val;
        (*i)->getValue(config, val);

        if("left_thumb_ext"==(*i)->name){left_thumb_ext = boost::any_cast<std::string>(val);}
        if("left_thumb_med_ext"==(*i)->name){left_thumb_med_ext = boost::any_cast<std::string>(val);}
        if("left_thumb_med_flex"==(*i)->name){left_thumb_med_flex = boost::any_cast<std::string>(val);}
        if("left_thumb_dist_ext"==(*i)->name){left_thumb_dist_ext = boost::any_cast<std::string>(val);}
        if("left_thumb_dist_flex"==(*i)->name){left_thumb_dist_flex = boost::any_cast<std::string>(val);}
        if("left_index_prox_ext"==(*i)->name){left_index_prox_ext = boost::any_cast<std::string>(val);}
        if("left_index_prox_flex"==(*i)->name){left_index_prox_flex = boost::any_cast<std::string>(val);}
        if("left_index_med_ext"==(*i)->name){left_index_med_ext = boost::any_cast<std::string>(val);}
        if("left_index_med_flex"==(*i)->name){left_index_med_flex = boost::any_cast<std::string>(val);}
        if("left_middle_prox_ext"==(*i)->name){left_middle_prox_ext = boost::any_cast<std::string>(val);}
        if("left_middle_prox_flex"==(*i)->name){left_middle_prox_flex = boost::any_cast<std::string>(val);}
        if("left_middle_med_ext"==(*i)->name){left_middle_med_ext = boost::any_cast<std::string>(val);}
        if("left_middle_med_flex"==(*i)->name){left_middle_med_flex = boost::any_cast<std::string>(val);}
        if("left_ring_flex"==(*i)->name){left_ring_flex = boost::any_cast<std::string>(val);}
        if("left_little_flex"==(*i)->name){left_little_flex = boost::any_cast<std::string>(val);}
        if("left_ring_little_ext"==(*i)->name){left_ring_little_ext = boost::any_cast<std::string>(val);}
        if("right_thumb_ext"==(*i)->name){right_thumb_ext = boost::any_cast<std::string>(val);}
        if("right_thumb_med_ext"==(*i)->name){right_thumb_med_ext = boost::any_cast<std::string>(val);}
        if("right_thumb_med_flex"==(*i)->name){right_thumb_med_flex = boost::any_cast<std::string>(val);}
        if("right_thumb_dist_ext"==(*i)->name){right_thumb_dist_ext = boost::any_cast<std::string>(val);}
        if("right_thumb_dist_flex"==(*i)->name){right_thumb_dist_flex = boost::any_cast<std::string>(val);}
        if("right_index_prox_ext"==(*i)->name){right_index_prox_ext = boost::any_cast<std::string>(val);}
        if("right_index_prox_flex"==(*i)->name){right_index_prox_flex = boost::any_cast<std::string>(val);}
        if("right_index_med_ext"==(*i)->name){right_index_med_ext = boost::any_cast<std::string>(val);}
        if("right_index_med_flex"==(*i)->name){right_index_med_flex = boost::any_cast<std::string>(val);}
        if("right_middle_prox_ext"==(*i)->name){right_middle_prox_ext = boost::any_cast<std::string>(val);}
        if("right_middle_prox_flex"==(*i)->name){right_middle_prox_flex = boost::any_cast<std::string>(val);}
        if("right_middle_med_ext"==(*i)->name){right_middle_med_ext = boost::any_cast<std::string>(val);}
        if("right_middle_med_flex"==(*i)->name){right_middle_med_flex = boost::any_cast<std::string>(val);}
        if("right_ring_flex"==(*i)->name){right_ring_flex = boost::any_cast<std::string>(val);}
        if("right_little_flex"==(*i)->name){right_little_flex = boost::any_cast<std::string>(val);}
        if("right_ring_little_ext"==(*i)->name){right_ring_little_ext = boost::any_cast<std::string>(val);}
      }
    }

    std::string left_thumb_ext;
std::string left_thumb_med_ext;
std::string left_thumb_med_flex;
std::string left_thumb_dist_ext;
std::string left_thumb_dist_flex;
std::string left_index_prox_ext;
std::string left_index_prox_flex;
std::string left_index_med_ext;
std::string left_index_med_flex;
std::string left_middle_prox_ext;
std::string left_middle_prox_flex;
std::string left_middle_med_ext;
std::string left_middle_med_flex;
std::string left_ring_flex;
std::string left_little_flex;
std::string left_ring_little_ext;
std::string right_thumb_ext;
std::string right_thumb_med_ext;
std::string right_thumb_med_flex;
std::string right_thumb_dist_ext;
std::string right_thumb_dist_flex;
std::string right_index_prox_ext;
std::string right_index_prox_flex;
std::string right_index_med_ext;
std::string right_index_med_flex;
std::string right_middle_prox_ext;
std::string right_middle_prox_flex;
std::string right_middle_med_ext;
std::string right_middle_med_flex;
std::string right_ring_flex;
std::string right_little_flex;
std::string right_ring_little_ext;

    bool state;
    std::string name;

    
}groups;



//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_thumb_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_thumb_med_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_thumb_med_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_thumb_dist_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_thumb_dist_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_index_prox_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_index_prox_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_index_med_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_index_med_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_middle_prox_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_middle_prox_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_middle_med_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_middle_med_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_ring_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_little_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string left_ring_little_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_thumb_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_thumb_med_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_thumb_med_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_thumb_dist_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_thumb_dist_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_index_prox_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_index_prox_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_index_med_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_index_med_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_middle_prox_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_middle_prox_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_middle_med_ext;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_middle_med_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_ring_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_little_flex;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string right_ring_little_ext;
//#line 255 "/opt/ros/fuerte/stacks/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("kTendonConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const kTendonConfig &__max__ = __getMax__();
      const kTendonConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const kTendonConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const kTendonConfig &__getDefault__();
    static const kTendonConfig &__getMax__();
    static const kTendonConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const kTendonConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void kTendonConfig::ParamDescription<std::string>::clamp(kTendonConfig &config, const kTendonConfig &max, const kTendonConfig &min) const
  {
    return;
  }

  class kTendonConfigStatics
  {
    friend class kTendonConfig;
    
    kTendonConfigStatics()
    {
kTendonConfig::GroupDescription<kTendonConfig::DEFAULT, kTendonConfig> Default("Default", "", 0, 0, true, &kTendonConfig::groups);
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_thumb_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_thumb_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_thumb_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_ext", "str", 0, "KTendon Left Thumb Extensor", "", &kTendonConfig::left_thumb_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_ext", "str", 0, "KTendon Left Thumb Extensor", "", &kTendonConfig::left_thumb_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_thumb_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_thumb_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_thumb_med_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_med_ext", "str", 0, "KTendon Left Thumb Medial Extensor", "", &kTendonConfig::left_thumb_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_med_ext", "str", 0, "KTendon Left Thumb Medial Extensor", "", &kTendonConfig::left_thumb_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_thumb_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_thumb_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_thumb_med_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_med_flex", "str", 0, "KTendon Left Thumb Medial Flexor", "", &kTendonConfig::left_thumb_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_med_flex", "str", 0, "KTendon Left Thumb Medial Flexor", "", &kTendonConfig::left_thumb_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_thumb_dist_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_thumb_dist_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_thumb_dist_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_dist_ext", "str", 0, "KTendon Left Thumb Distal Extensor", "", &kTendonConfig::left_thumb_dist_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_dist_ext", "str", 0, "KTendon Left Thumb Distal Extensor", "", &kTendonConfig::left_thumb_dist_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_thumb_dist_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_thumb_dist_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_thumb_dist_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_dist_flex", "str", 0, "KTendon Left Thumb Distal Flexor", "", &kTendonConfig::left_thumb_dist_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_thumb_dist_flex", "str", 0, "KTendon Left Thumb Distal Flexor", "", &kTendonConfig::left_thumb_dist_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_index_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_index_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_index_prox_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_prox_ext", "str", 0, "KTendon Left Index Proximal Extensor", "", &kTendonConfig::left_index_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_prox_ext", "str", 0, "KTendon Left Index Proximal Extensor", "", &kTendonConfig::left_index_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_index_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_index_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_index_prox_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_prox_flex", "str", 0, "KTendon Left Index Proximal Flexor", "", &kTendonConfig::left_index_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_prox_flex", "str", 0, "KTendon Left Index Proximal Flexor", "", &kTendonConfig::left_index_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_index_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_index_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_index_med_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_med_ext", "str", 0, "KTendon Left Index Medial Extensor", "", &kTendonConfig::left_index_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_med_ext", "str", 0, "KTendon Left Index Medial Extensor", "", &kTendonConfig::left_index_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_index_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_index_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_index_med_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_med_flex", "str", 0, "KTendon Left Index Medial Flexor", "", &kTendonConfig::left_index_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_index_med_flex", "str", 0, "KTendon Left Index Medial Flexor", "", &kTendonConfig::left_index_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_middle_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_middle_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_middle_prox_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_prox_ext", "str", 0, "KTendon Left Middle Proximal Extensor", "", &kTendonConfig::left_middle_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_prox_ext", "str", 0, "KTendon Left Middle Proximal Extensor", "", &kTendonConfig::left_middle_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_middle_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_middle_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_middle_prox_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_prox_flex", "str", 0, "KTendon Left Middle Proximal Flexor", "", &kTendonConfig::left_middle_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_prox_flex", "str", 0, "KTendon Left Middle Proximal Flexor", "", &kTendonConfig::left_middle_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_middle_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_middle_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_middle_med_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_med_ext", "str", 0, "KTendon Left Middle Medial Extensor", "", &kTendonConfig::left_middle_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_med_ext", "str", 0, "KTendon Left Middle Medial Extensor", "", &kTendonConfig::left_middle_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_middle_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_middle_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_middle_med_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_med_flex", "str", 0, "KTendon Left Middle Medial Flexor", "", &kTendonConfig::left_middle_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_middle_med_flex", "str", 0, "KTendon Left Middle Medial Flexor", "", &kTendonConfig::left_middle_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_ring_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_ring_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_ring_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_ring_flex", "str", 0, "KTendon Left Ring Flexor", "", &kTendonConfig::left_ring_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_ring_flex", "str", 0, "KTendon Left Ring Flexor", "", &kTendonConfig::left_ring_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_little_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_little_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_little_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_little_flex", "str", 0, "KTendon Left Little Flexor", "", &kTendonConfig::left_little_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_little_flex", "str", 0, "KTendon Left Little Flexor", "", &kTendonConfig::left_little_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.left_ring_little_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.left_ring_little_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.left_ring_little_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_ring_little_ext", "str", 0, "KTendon Left Ring Little Extensor", "", &kTendonConfig::left_ring_little_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("left_ring_little_ext", "str", 0, "KTendon Left Ring Little Extensor", "", &kTendonConfig::left_ring_little_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_thumb_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_thumb_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_thumb_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_ext", "str", 0, "KTendon Right Thumb Extensor", "", &kTendonConfig::right_thumb_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_ext", "str", 0, "KTendon Right Thumb Extensor", "", &kTendonConfig::right_thumb_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_thumb_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_thumb_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_thumb_med_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_med_ext", "str", 0, "KTendon Right Thumb Medial Extensor", "", &kTendonConfig::right_thumb_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_med_ext", "str", 0, "KTendon Right Thumb Medial Extensor", "", &kTendonConfig::right_thumb_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_thumb_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_thumb_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_thumb_med_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_med_flex", "str", 0, "KTendon Right Thumb Medial Flexor", "", &kTendonConfig::right_thumb_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_med_flex", "str", 0, "KTendon Right Thumb Medial Flexor", "", &kTendonConfig::right_thumb_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_thumb_dist_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_thumb_dist_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_thumb_dist_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_dist_ext", "str", 0, "KTendon Right Thumb Distal Extensor", "", &kTendonConfig::right_thumb_dist_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_dist_ext", "str", 0, "KTendon Right Thumb Distal Extensor", "", &kTendonConfig::right_thumb_dist_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_thumb_dist_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_thumb_dist_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_thumb_dist_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_dist_flex", "str", 0, "KTendon Right Thumb Distal Flexor", "", &kTendonConfig::right_thumb_dist_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_thumb_dist_flex", "str", 0, "KTendon Right Thumb Distal Flexor", "", &kTendonConfig::right_thumb_dist_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_index_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_index_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_index_prox_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_prox_ext", "str", 0, "KTendon Right Index Proximal Extensor", "", &kTendonConfig::right_index_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_prox_ext", "str", 0, "KTendon Right Index Proximal Extensor", "", &kTendonConfig::right_index_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_index_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_index_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_index_prox_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_prox_flex", "str", 0, "KTendon Right Index Proximal Flexor", "", &kTendonConfig::right_index_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_prox_flex", "str", 0, "KTendon Right Index Proximal Flexor", "", &kTendonConfig::right_index_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_index_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_index_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_index_med_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_med_ext", "str", 0, "KTendon Right Index Medial Extensor", "", &kTendonConfig::right_index_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_med_ext", "str", 0, "KTendon Right Index Medial Extensor", "", &kTendonConfig::right_index_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_index_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_index_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_index_med_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_med_flex", "str", 0, "KTendon Right Index Medial Flexor", "", &kTendonConfig::right_index_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_index_med_flex", "str", 0, "KTendon Right Index Medial Flexor", "", &kTendonConfig::right_index_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_middle_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_middle_prox_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_middle_prox_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_prox_ext", "str", 0, "KTendon Right Middle Proximal Extensor", "", &kTendonConfig::right_middle_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_prox_ext", "str", 0, "KTendon Right Middle Proximal Extensor", "", &kTendonConfig::right_middle_prox_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_middle_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_middle_prox_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_middle_prox_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_prox_flex", "str", 0, "KTendon Right Middle Proximal Flexor", "", &kTendonConfig::right_middle_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_prox_flex", "str", 0, "KTendon Right Middle Proximal Flexor", "", &kTendonConfig::right_middle_prox_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_middle_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_middle_med_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_middle_med_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_med_ext", "str", 0, "KTendon Right Middle Medial Extensor", "", &kTendonConfig::right_middle_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_med_ext", "str", 0, "KTendon Right Middle Medial Extensor", "", &kTendonConfig::right_middle_med_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_middle_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_middle_med_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_middle_med_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_med_flex", "str", 0, "KTendon Right Middle Medial Flexor", "", &kTendonConfig::right_middle_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_middle_med_flex", "str", 0, "KTendon Right Middle Medial Flexor", "", &kTendonConfig::right_middle_med_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_ring_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_ring_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_ring_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_ring_flex", "str", 0, "KTendon Right Ring Flexor", "", &kTendonConfig::right_ring_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_ring_flex", "str", 0, "KTendon Right Ring Flexor", "", &kTendonConfig::right_ring_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_little_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_little_flex = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_little_flex = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_little_flex", "str", 0, "KTendon Right Little Flexor", "", &kTendonConfig::right_little_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_little_flex", "str", 0, "KTendon Right Little Flexor", "", &kTendonConfig::right_little_flex)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.right_ring_little_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.right_ring_little_ext = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.right_ring_little_ext = "5.0";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_ring_little_ext", "str", 0, "KTendon Right Ring Little Extensor", "", &kTendonConfig::right_ring_little_ext)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(kTendonConfig::AbstractParamDescriptionConstPtr(new kTendonConfig::ParamDescription<std::string>("right_ring_little_ext", "str", 0, "KTendon Right Ring Little Extensor", "", &kTendonConfig::right_ring_little_ext)));
//#line 233 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.convertParams();
//#line 233 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __group_descriptions__.push_back(kTendonConfig::AbstractGroupDescriptionConstPtr(new kTendonConfig::GroupDescription<kTendonConfig::DEFAULT, kTendonConfig>(Default)));
//#line 390 "/opt/ros/fuerte/stacks/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<kTendonConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<kTendonConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<kTendonConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    kTendonConfig __max__;
    kTendonConfig __min__;
    kTendonConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const kTendonConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static kTendonConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &kTendonConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const kTendonConfig &kTendonConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const kTendonConfig &kTendonConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const kTendonConfig &kTendonConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<kTendonConfig::AbstractParamDescriptionConstPtr> &kTendonConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<kTendonConfig::AbstractGroupDescriptionConstPtr> &kTendonConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const kTendonConfigStatics *kTendonConfig::__get_statics__()
  {
    const static kTendonConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = kTendonConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __KTENDONRECONFIGURATOR_H__
